using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace Lufthavn
{
    class Buffer
    {
        private object[] data;
        private int head = 0;
        private int count = 0;

        public Buffer(int size)
        {
            data = new object[size];
        }

        public void add(object elm)
        {
            lock (this)
            {
                try
                {
                    while (count == data.Length)
                    {
                        Monitor.Wait(this);
                    }
                    int tail = (head + count) % data.Length;
                    data[tail] = elm;
                    ++count;
                    if (count == 1)
                        Monitor.PulseAll(this);
                }
                catch { }
            }
        }

        public object remove()
        {
            object elm = null;
            lock (this)
            {
                try
                {
                    while (count == 0)
                    {
                        Monitor.Wait(this);
                    }
                    elm = data[head];
                    data[head] = null;
                    --count;
                    head = (head + 1) % data.Length;

                    if (count == data.Length - 1)
                        Monitor.PulseAll(this);
                }
                catch { }
            }
            return elm;
        }
    }
}
