using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace Lufthavn
{
    public delegate void ConsumerWrite(string txt);

    class Consumer
    {
        private ConsumerWrite write;
        private Form1 form;
        private string name;
        private Buffer buf;
        private Thread trd;
        private volatile bool active = true;

        public Consumer(Buffer buf, string name, Form1 form,ConsumerWrite write)
        {
            this.buf = buf;
            this.name = name;
            this.form = form;
            this.write = write;
            this.trd = new Thread(run);
            trd.Start();
        }
        private void run()
        {
            Random rand = new Random();
            while (active)
            {
                try {
                    int tal = (int)buf.remove();
                    string txt = "" + name + " Consumet " + tal;
                    write(txt);
                    //form.Invoke(new ConsumerWrite(form.skriv),txt);
                    Thread.Sleep(rand.Next(1, 100));
                }
                catch { };
            }

        }
        public void Start()
        {
            active = true;
        }
        public void Stop()
        {
            active = false;
            this.trd.Interrupt();
        }

    }
}
